"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class EvidenceEntry(ProtocolElement):
    """
    An entry for an evidence
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "ethnicity",
        "source",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import opencb as opencb_1_3_0

        return {
            "additionalProperties": opencb_1_3_0.Property,
            "genomicFeatures": opencb_1_3_0.GenomicFeature,
            "heritableTraits": opencb_1_3_0.HeritableTrait,
            "somaticInformation": opencb_1_3_0.SomaticInformation,
            "source": opencb_1_3_0.EvidenceSource,
            "submissions": opencb_1_3_0.EvidenceSubmission,
            "variantClassification": opencb_1_3_0.VariantClassification,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import opencb as opencb_1_3_0

        return {
            "alleleOrigin": opencb_1_3_0.AlleleOrigin,
            "confidence": opencb_1_3_0.Confidence,
            "consistencyStatus": opencb_1_3_0.ConsistencyStatus,
            "ethnicity": opencb_1_3_0.EthnicCategory,
            "impact": opencb_1_3_0.EvidenceImpact,
            "penetrance": opencb_1_3_0.Penetrance,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2_1 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.variant.avro.Property": opencb_1_3_0.Property,
            "org.opencb.biodata.models.variant.avro.AlleleOrigin": opencb_1_3_0.AlleleOrigin,
            "org.opencb.biodata.models.variant.avro.Confidence": opencb_1_3_0.Confidence,
            "org.opencb.biodata.models.variant.avro.ConsistencyStatus": opencb_1_3_0.ConsistencyStatus,
            "org.opencb.biodata.models.variant.avro.EthnicCategory": opencb_1_3_0.EthnicCategory,
            "org.opencb.biodata.models.variant.avro.GenomicFeature": opencb_1_3_0.GenomicFeature,
            "org.opencb.biodata.models.variant.avro.HeritableTrait": opencb_1_3_0.HeritableTrait,
            "org.opencb.biodata.models.variant.avro.EvidenceImpact": opencb_1_3_0.EvidenceImpact,
            "org.opencb.biodata.models.variant.avro.Penetrance": opencb_1_3_0.Penetrance,
            "org.opencb.biodata.models.variant.avro.SomaticInformation": opencb_1_3_0.SomaticInformation,
            "org.opencb.biodata.models.variant.avro.EvidenceSource": opencb_1_3_0.EvidenceSource,
            "org.opencb.biodata.models.variant.avro.EvidenceSubmission": opencb_1_3_0.EvidenceSubmission,
            "org.opencb.biodata.models.variant.avro.VariantClassification": opencb_1_3_0.VariantClassification,
            "org.opencb.biodata.models.variant.avro.EvidenceEntry": opencb_1_3_0.EvidenceEntry,
        }

    __slots__ = [
        "ethnicity",
        "source",
        "additionalProperties",
        "alleleOrigin",
        "assembly",
        "bibliography",
        "confidence",
        "consistencyStatus",
        "description",
        "genomicFeatures",
        "heritableTraits",
        "id",
        "impact",
        "penetrance",
        "somaticInformation",
        "submissions",
        "url",
        "variableExpressivity",
        "variantClassification",
    ]

    def __init__(
        self,
        ethnicity,
        source,
        additionalProperties=list,
        alleleOrigin=None,
        assembly=None,
        bibliography=list,
        confidence=None,
        consistencyStatus=None,
        description=None,
        genomicFeatures=list,
        heritableTraits=list,
        id=None,
        impact=None,
        penetrance=None,
        somaticInformation=None,
        submissions=list,
        url=None,
        variableExpressivity=None,
        variantClassification=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.EvidenceEntry model.

        :param ethnicity:
            Ethnicity
        :type ethnicity: EthnicCategory
        :param source:
            Source of the evidence
        :type source: EvidenceSource
        :param additionalProperties:
            A list of additional properties in the form name-value.
        :type additionalProperties: list[Property]
        :param alleleOrigin:
            List of allele origins
        :type alleleOrigin: None | list[AlleleOrigin]
        :param assembly:
            The reference genome assembly
        :type assembly: None | str
        :param bibliography:
            Bibliography
        :type bibliography: list[str]
        :param confidence:
            The curation confidence.
        :type confidence: None | Confidence
        :param consistencyStatus:
            The consistency status. This is applicable to complex evidences (e.g.:
            ClinVar)
        :type consistencyStatus: None | ConsistencyStatus
        :param description:
            Evidence description
        :type description: None | str
        :param genomicFeatures:
            The transcript to which the evidence refers
        :type genomicFeatures: list[GenomicFeature]
        :param heritableTraits:
            Heritable traits associated to this evidence
        :type heritableTraits: list[HeritableTrait]
        :param id:
            ID of record in the source
        :type id: None | str
        :param impact:
            Impact of evidence. Should be coherent with the classification of
            impact if provided.
        :type impact: None | EvidenceImpact
        :param penetrance:
            The penetrance of the phenotype for this genotype. Value in the range
            [0, 1]
        :type penetrance: None | Penetrance
        :param somaticInformation:
            The somatic information
        :type somaticInformation: None | SomaticInformation
        :param submissions:
            The list of submissions
        :type submissions: list[EvidenceSubmission]
        :param url:
            URL of source if any
        :type url: None | str
        :param variableExpressivity:
            Variable expressivity of a given phenotype for the same genotype
        :type variableExpressivity: None | boolean
        :param variantClassification:
            The variant classification
        :type variantClassification: None | VariantClassification
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
